ProcedureDLL AttachProcess(Instance)
	Global FunctionB3D
	Global PointerB3D
	Global ThreadID
	Global Threads
	NewList Threads()
EndProcedure

ProcedureDLL DetachProcess(Instance)
	ForEach Threads()
		KillThread(Threads())
	Next
	ClearList(Threads()) 
EndProcedure

Procedure ThreadFindEx()
	FunctionB3D=0
	FunctionDebug=0
	res=0
	ptr=PointerB3D
	For i=1 To 10
		ptr0=DisASMCommand(ptr)
		If Left(GetDisASMString(),4)="CALL"
 			FunctionDebug=PeekL(ptr+1)+ptr0
		EndIf
		If Left(GetDisASMString(),3)="JMP"
			last=PeekL(ptr+1)+ptr0
			res=1
			Break
		EndIf
		ptr=ptr0
	Next
	If res=1 And ptr<last
		Repeat
			ptr0=DisASMCommand(ptr)
			If Left(GetDisASMString(),4)="CALL"
				res=PeekL(ptr+1)+ptr0
				If res<>FunctionDebug
					FunctionB3D=res
				EndIf
			EndIf
			ptr=ptr0
		Until ptr>last
 	EndIf
EndProcedure

Procedure ThreadCreateEx()
 	If FunctionB3D<>0
		ThreadID=CreateThread(FunctionB3D,0)
		If ThreadID<>0
			AddElement(Threads())
			Threads()=ThreadID
		EndIf
 	EndIf		
EndProcedure

ProcedureDLL ThreadCreate()
 	MOV Eax,[Esp+20]
	MOV PointerB3D,Eax
	ThreadFindEx()
	ThreadCreateEx()
	ProcedureReturn ThreadID
EndProcedure

ProcedureDLL ThreadKill(TID)
	KillThread(TID)
	ForEach Threads()
		If Threads()=TID
			DeleteElement(Threads())
		EndIf
	Next
EndProcedure

ProcedureDLL ThreadPrior(TID,Priority)
	If Priority>16
		Priority=16
	EndIf
	If Priority<0
		Priority=0
	EndIf
	ProcedureReturn ThreadPriority(TID, Priority)
EndProcedure

ProcedureDLL ThreadPause(TID)
	PauseThread(ThreadID)
EndProcedure

ProcedureDLL ThreadResume(TID)
	ResumeThread(ThreadID)
EndProcedure

ProcedureDLL ThreadWait(TID)
	WaitThread(ThreadID)
EndProcedure

; IDE Options = PureBasic v3.94 Beta 3 (Windows - x86)
; ExecutableFormat = Shared Dll
; EnableAsm
; Executable = ThreadB3D.dll
; DisableDebugger